using System;

namespace PALINDROM_SAFL
{
    class Program
    {
        static void Main(string[] args)
        {
            string T = Console.ReadLine();
            string k = Palindrom(T);
            int i = 0;
            int j = T.Length - 1;
            if (T == k)
            {
                Console.WriteLine("1");
            }
            else
            {
                while (T[i] == k[i])
                {
                    i++;
                }
                while (T[j] == k[j])
                {
                    j--;
                }
                Console.WriteLine(j - i + 1);
            }
        }

        static string Palindrom(string s)
        {
            string t = s;
            int prvi = 0;
            int poslednji = s.Length - 1;
            while (t.Length > 1)
            {
                if (t[0] == t[t.Length - 1])
                {
                    prvi++;
                    poslednji--;
                    t = s.Substring(prvi, poslednji - prvi + 1);
                }
                else
                {
                    char a = s[prvi];
                    prvi++;
                    t = s.Substring(prvi, poslednji - prvi + 1);
                    if (t.IndexOf(a) == -1)
                    {
                        char[] c = s.ToCharArray();
                        char pom = c[prvi - 1];
                        c[prvi - 1] = c[s.Length / 2];
                        c[s.Length / 2] = pom;
                        s = new string(c);
                        prvi--;
                    }
                    else
                    {
                        char[] c = s.ToCharArray();
                        char pom = c[prvi + t.IndexOf(a)];
                        c[prvi + t.IndexOf(a)] = c[poslednji];
                        c[poslednji] = pom;
                        s = new string(c);
                        poslednji--;
                        t = s.Substring(prvi, poslednji - prvi);
                    }
                }
            }
            return s;
        }
    }
}